<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:h="http://java.sun.com/jsf/html" xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml" template="/layout/template.xhtml">
    <ui:define name="body">
        #{certificateBean.initialize()}
        <h2><h:outputText value="#{messages['net.ihe.gazelle.atna.Custom']}" rendered="#{certificateBean.cert.isCustom()}"/>#{messages['net.ihe.gazelle.atna.Certificate']}</h2>
        <h:form>

            <ui:decorate template="/layout/panels/_panel_title.xhtml">
                <ui:define name="panel_title">#{messages['net.ihe.gazelle.atna.CertificateDetails']}</ui:define>

                <div class="container-fluid">
                    <div class="row">
                        <div class="col-xs-9">
                            <dl class="dl-horizontal">
                                <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Id']}</ui:define>
                                    <h:outputText value="#{certificateBean.cert.id}"/>
                                </ui:decorate>
                                <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.Subject']}</ui:define>
                                    <h:outputText value="#{certificateBean.cert.subject}"/>
                                </ui:decorate>

                                <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.questionnaire.Type']}</ui:define>
                                    <h:outputText
                                            value="#{certificateBean.cert.request.certificateExtension.getFriendlyName()}"
                                            rendered="#{certificateBean.cert.request != null}"/>
                                    <h:outputText value="#{messages['net.ihe.gazelle.atna.Unknown']}"
                                                  rendered="#{certificateBean.cert.request == null}"/>
                                </ui:decorate>
                                <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.SerialNumber']}</ui:define>
                                    <h:outputText value="#{certificateBean.cert.serialNumber}"/>
                                </ui:decorate>
                                <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.CertificateAuthority_3']}</ui:define>
                                    <h:outputText value="#{certificateBean.cert.certificateAuthority.subject}"
                                                  rendered="#{certificateBean.cert.certificateAuthority != null}"/>
                                    <h:outputText value="#{messages['net.ihe.gazelle.atna.None']}"
                                                  rendered="#{certificateBean.cert.certificateAuthority == null}"/>
                                </ui:decorate>
                                <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.NumberOfCRL']}</ui:define>
                                    <h:outputText value="#{certificateBean.cert.crlNumber}"/>
                                </ui:decorate>
                                <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.Requester']}</ui:define>
                                    <h:outputText value="#{certificateBean.getUserName(certificateBean.cert.request.requesterUsernameWithKey)}"
                                                  rendered="#{certificateBean.cert.request != null}"/>
                                    <h:outputText value="#{messages['net.ihe.gazelle.atna.None']}"
                                                  rendered="#{certificateBean.cert.request == null}"/>
                                </ui:decorate>
                                <ui:decorate template="/layout/display/_data_list_item.xhtml">
                                    <ui:define name="label">#{messages['net.ihe.gazelle.atna.SubjectAlternativeNames']}</ui:define>
                                    <h:outputText value="#{certificateBean.cert.getSubjectAlternativeName()}"
                                                  rendered="#{certificateBean.cert.getSubjectAlternativeName() != null and !certificateBean.cert.getSubjectAlternativeName().isEmpty()}" />
                                    <h:outputText value="#{messages['net.ihe.gazelle.atna.None']}"
                                                  rendered="#{(certificateBean.cert.getSubjectAlternativeName() == null) or (certificateBean.cert.getSubjectAlternativeName() != null and certificateBean.cert.getSubjectAlternativeName().isEmpty())}" />

                                </ui:decorate>
                            </dl>
                        </div>
                        <div class="col-xs-3">
                            <div class="btn-group pull-right">
                                <button type="button" class="gzl-btn dropdown-toggle" data-toggle="dropdown"
                                        aria-haspopup="true" aria-expanded="false">
                                    #{messages['net.ihe.gazelle.atna.Download']} <span class="caret"></span>
                                </button>

                                <ul class="dropdown-menu dropdown-menu-right text-right">
                                    <li>
                                        <h:commandLink action="#{certificateBean.downloadPEM()}"
                                                       title="#{messages['net.ihe.gazelle.atna.PEMFilesCanBeRenamedWithcrtExtension']}"
                                                       value="#{messages['net.ihe.gazelle.atna.CertificateInPEMFormat']}"/>
                                    </li>
                                    <li>
                                        <h:commandLink action="#{certificateBean.downloadDER()}"
                                                       value="#{messages['net.ihe.gazelle.atna.CertificateInDERFormat']}"/>
                                    </li>
                                    <h:panelGroup rendered="#{certificateBean.isPrivateKeyAvailable()}">
                                        <li>
                                            <h:commandLink action="#{certificateBean.downloadKEY()}"
                                                           value="#{messages['net.ihe.gazelle.atna.PrivateKeyInPEMFormat']}"/>
                                        </li>
                                    </h:panelGroup>
                                    <li role="separator" class="divider"></li>
                                    <li>
                                        <a onclick="jq162('#keystoreModal').modal('show');" href="#">#{messages['net.ihe.gazelle.atna.Keystore']}</a>
                                    </li>
                                </ul>
                            </div>
                        </div>
                    </div>
                </div>

                <dl class="dl-horizontal">
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.Revocation']}</ui:define>
                        <h:panelGroup rendered="#{!certificateBean.cert.revoked}">
                            <div class="panel panel-success">
                                <div class="panel-body bg-success">
                                    <h:outputText value="#{messages['net.ihe.gazelle.atna.TheCertificateIsNotRevoked']}"/>
                                </div>
                            </div>
                        </h:panelGroup>
                        <h:panelGroup rendered="#{certificateBean.cert.revoked}">
                            <div class="panel panel-danger">
                                <div class="panel-body bg-danger">
                                    #{messages['net.ihe.gazelle.atna.TheCertificateHasBeenRevoked']}<br/>
                                    <strong>#{messages['net.ihe.gazelle.atna.Date']} </strong>
                                    <g:date value="#{certificateBean.cert.revokedDate}"/>
                                    <br/>
                                    <strong>#{messages['net.ihe.gazelle.atna.Reason']} </strong>
                                    <h:outputText value="#{certificateBean.cert.revokedReason.getLabel()}"/>
                                </div>
                            </div>
                        </h:panelGroup>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.PublicKey']}</ui:define>
                        <pre class="small">#{certificateBean.getPublicKey()}</pre>
                    </ui:decorate>
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.PrivateKey']}</ui:define>
                        <h:panelGroup rendered="${certificateBean.isPrivateKeyAvailable()}">
                            <pre class="small">#{certificateBean.getPrivateKey()}</pre>
                        </h:panelGroup>
                        <h:panelGroup rendered="${!certificateBean.isPrivateKeyAvailable()}">
                            <h:outputText value="#{messages['net.ihe.gazelle.atna.RightsNeededNotAvailable']}"/>
                        </h:panelGroup>
                    </ui:decorate>
                </dl>


                <dl class="dl-horizontal">
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.IssuedCertificates']}</ui:define>
                        <h:panelGroup rendered="#{certificateBean.cert.certificates.size() &gt; 0}">
                            <rich:dataTable value="#{certificateBean.cert.certificates}" var="certificate">
                                <rich:column>
                                    <f:facet name="header">
                                        <h:outputText
                                                value="#{certificateBean.cert.certificates.size()}  #{messages['net.ihe.gazelle.atna.IssuedCertificates']}"/>
                                    </f:facet>
                                    <h:commandLink action="#{certificateBean.redirectToCert(certificate.id)}"
                                                   value="#{certificate.subject}" target="_blank"/>
                                </rich:column>
                            </rich:dataTable>
                        </h:panelGroup>
                        <h:panelGroup rendered="#{certificateBean.cert.certificates.size() == 0}">
                            <h:outputText value="#{messages['net.ihe.gazelle.atna.None']}"/>
                        </h:panelGroup>
                    </ui:decorate>
                </dl>


                <dl class="dl-horizontal">
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.ChainOfCertificates']}</ui:define>
                        <rich:dataTable value="#{certificateBean.cert.realChain}" var="certificate">
                            <rich:column>
                                <f:facet name="header">
                                    <h:outputText value="#{messages['net.ihe.gazelle.atna.ChainOfCertificates']}"/>
                                </f:facet>
                                <h:commandLink action="#{certificateBean.redirectToCert(certificate.id)}"
                                               value="#{certificate.subject}" target="_blank"/>
                            </rich:column>
                        </rich:dataTable>
                    </ui:decorate>
                </dl>

                <dl class="dl-horizontal">
                    <ui:decorate template="/layout/display/_data_list_item.xhtml">
                        <ui:define name="label">#{messages['net.ihe.gazelle.atna.DetailedChain']}</ui:define>
                        <pre class="small">#{certificateBean.getChain()}"</pre>
                    </ui:decorate>
                </dl>

            </ui:decorate>

            <div class="modal fade" id="keystoreModal" tabindex="-1" role="dialog" aria-labelledby="keystoreModalLabel">
                <div class="modal-dialog" role="document">
                    <div class="modal-content">
                        <div class="modal-header">
                            <button type="button" class="close" data-dismiss="modal" aria-label="Close"><span
                                    aria-hidden="true">&#215;</span></button>
                            <h4 class="modal-title" id="keystoreModalLabel">
                                <h:outputText value="#{messages['net.ihe.gazelle.atna.DownloadKeystore']}"/>
                            </h4>
                        </div>
                        <div class="modal-body">

                            <p>#{messages['net.ihe.gazelle.atna.DownloadAKeystoreToGetTheCertificatePackagedWith']}</p>
                            <ul>
                                <li>#{messages['net.ihe.gazelle.atna.P12FormatForBrowsersWindowsOS']}</li>
                                <li>#{messages['net.ihe.gazelle.atna.JKSFormatAcronymForJavaKeyStoreUsedByJavaClients']}
                                </li>
                            </ul>

                        </div>

                        <s:div styleClass="modal-body bg-warning" rendered="#{not certificateBean.isPrivateKeyAvailable()}">

                            <h5 class="text-warning">#{messages['net.ihe.gazelle.atna.ThePrivateKeyIsNotAvailable']}</h5>

                            <p>#{messages['net.ihe.gazelle.atna.YouMayHaveNotSufficientRightsToSeeIt']}
                                <h:outputText value="#{messages['net.ihe.gazelle.atna.PleaseLoginAndVerify']} " rendered="#{not identity.loggedIn}"/>
                                <h:outputText value="#{messages['net.ihe.gazelle.atna.Verify']} " rendered="#{identity.loggedIn}"/>
                                #{messages['net.ihe.gazelle.atna.YouAreRequestingForACertificateThatBelongsToYour']}
                            </p>

                            <div class="form-horizontal">
                                <s:decorate template="/layout/form/_form_field_horizontal_6-6.xhtml">
                                    <ui:param name="id" value="pkFileInput"/>
                                    <ui:define name="label">
                                        #{messages['net.ihe.gazelle.atna.PrivateKeyInPEMFormatwillNotBeStoredOnTheServer']})
                                    </ui:define>

                                    <rich:fileUpload id="pkFileInput"
                                                     fileUploadListener="#{certificateBean.uploadListener}"
                                                     maxFilesQuantity="1"
                                                     acceptedTypes="pem,key,crt" listHeight="60px"
                                                     immediateUpload="true"/>
                                </s:decorate>
                                <s:decorate template="/layout/form/_form_field_horizontal_6-6.xhtml">
                                    <ui:param name="id" value="pkPwdInput"/>
                                    <ui:define name="label">
                                        #{messages['net.ihe.gazelle.atna.PrivateKeyPasswordifRequiredwillNotBeStoredOnThe']})
                                    </ui:define>
                                    <h:inputSecret id="pkPwdInput" value="#{certificateBean.pkpassword}"
                                                   styleClass="form-control"/>
                                </s:decorate>
                            </div>

                        </s:div>

                        <div class="modal-body">

                            <div class="form-horizontal">

                                <s:decorate template="/layout/form/_form_field_horizontal_6-6.xhtml">
                                    <ui:param name="id" value="pwdInput"/>
                                    <ui:define name="label">
                                        #{messages['net.ihe.gazelle.atna.DefineThePasswordForTheKeystore']}
                                    </ui:define>
                                    <h:inputText id="pwdInput" value="#{certificateBean.generatePassword}"
                                                 styleClass="form-control"/>
                                </s:decorate>

                                <s:decorate template="/layout/form/_form_field_horizontal_6-6.xhtml">
                                    <ui:param name="id" value="jksAliasInput"/>
                                    <ui:define name="label">
                                        #{messages['net.ihe.gazelle.atna.AliasForPrivateKeyonlyForJKS']})
                                    </ui:define>
                                    <h:inputText id="jksAliasInput" value="#{certificateBean.generateAlias}"
                                                 styleClass="form-control"/>
                                </s:decorate>

                            </div>

                        </div>
                        <div class="modal-footer">
                            <button type="button" class="gzl-btn" data-dismiss="modal">#{messages['net.ihe.gazelle.atna.Cancel']}</button>
                            <h:panelGroup rendered="#{certificateBean.isPrivateKeyAvailable()}">
                                <h:commandButton action="#{certificateBean.downloadP12()}"
                                                 onclick="jq162('#keystoreModal').modal('hide')"
                                                 value="#{messages['net.ihe.gazelle.atna.P12Keystore']}"
                                                 styleClass="gzl-btn-blue" target="_blank"/>
                                <h:commandButton action="#{certificateBean.downloadJKS()}"
                                                 onclick="jq162('#keystoreModal').modal('hide')"
                                                 value="#{messages['net.ihe.gazelle.atna.JKSKeystore']}"
                                                 styleClass="gzl-btn-blue" target="_blank"/>
                            </h:panelGroup>
                            <h:panelGroup rendered="#{not certificateBean.isPrivateKeyAvailable()}">
                                <h:commandButton action="#{certificateBean.generateP12()}"
                                                 onclick="jq162('#keystoreModal').modal('hide')"
                                                 value="#{messages['net.ihe.gazelle.atna.P12Keystore']}"
                                                 styleClass="gzl-btn-blue" target="_blank"/>
                                <h:commandButton action="#{certificateBean.generateJKS()}"
                                                 onclick="jq162('#keystoreModal').modal('hide')"
                                                 value="#{messages['net.ihe.gazelle.atna.JKSKeystore']}"
                                                 styleClass="gzl-btn-blue" target="_blank"/>
                            </h:panelGroup>
                        </div>
                    </div>
                </div>
            </div>

        </h:form>

    </ui:define>
</ui:composition>
